using System.Xml;
using System.Xml.Serialization; //tridy pro praci s XML

//Upravte pracu so streamamy tak, aby pri neexistencii suboru, alebo pri nemoznosti zapisu program nespadol.
namespace IW5_cv02
{
  public class XMLWorker //: IWorker
  {
    public XMLWorker(string path)
    {
      this.fullFilePath = path + XML_PATH;
    }

    public XMLWorker() : this("") {}

    private const string XML_PATH = @"person.xml";
    private string fullFilePath;
    
    public Person Load()
    {
      XmlSerializer s = new XmlSerializer(typeof(Person));

      XmlTextReader xmlReader = new XmlTextReader(this.fullFilePath);
      Person retPerson = (Person)s.Deserialize(xmlReader);
      xmlReader.Close();

      return retPerson;
    }

    public void Save(Person person)
    {
      XmlSerializer s = new XmlSerializer(typeof(Person));
      XmlTextWriter xmlWriter = new XmlTextWriter(this.fullFilePath, System.Text.Encoding.UTF8);

      s.Serialize(xmlWriter, person);
      xmlWriter.Close();
    }
  }
}
